/*==================================================*
 *                                                  *
 *      Su pasirinktais raais realizuoti ADT      *
 *      srao operacijas masyvo pagrindu           *
 *                                                  *
 *==================================================*/

#include <iostream>
#include <fstream>
#include <string>
using namespace std;
const int C = 20;

void printMenu();
void loadList(int myList[C]);
void printList(int myList[C]);
void insertElement(int myList[C]);
void deleteElement(int myList[C]);
void retrieveElement(int myList[C]);
void listLenght(int myList[C]);

int main() {

    int myList[21];
    for(int i = 1; i < C; i++){
            myList[i] = NULL;
    }

    for (;;)
    {
        cout << "\n----------------------------------------\n";
        cout << "(m - rodyti meniu) > ";
        string key;
        cin >> key;
             if (key == "0") return 0;
        else if (key == "m") printMenu        ();
        else if (key == "1") loadList         (myList);
        else if (key == "2") printList        (myList);
        else if (key == "3") insertElement    (myList); //L, x, i
        else if (key == "4") deleteElement    (myList); //L, i
        else if (key == "5") retrieveElement  (myList); //L, i
        else if (key == "6") listLenght       (myList); //L
        else cout << endl << "Neteisinga komanda..." << endl;
    }
    cout << endl;
    system("pause");
    return 0;
}

void printMenu ()
{
    cout << endl
         << "ADT saraso operacijos masyvo pagrindu"           << endl
         << "  1 - skaityti is failo"                         << endl
         << "  2 - spausdinti duomenis"                       << endl
         << "  3 - iterpti elementa i spec. saraso vieta"     << endl
         << "  4 - pasalinti saraso elementa is spec. vietos" << endl
         << "  5 - rasti elementa esanti spec. vietoje"       << endl
         << "  6 - saraso ilgis(elementu kiekis)"             << endl
         << endl
         << "  0 - Baigti darba"                              << endl;
}

void loadList(int myList[C]){
    int a;
    int i = 1;
    ifstream Failas("D:/Workshop/ADT/ADT_1/duom.txt");
    if (!Failas.is_open())
    {
        cout << "Nepavyko atidaryti failo" << endl;
    } else
    {
         while(!Failas.eof())
        {
            Failas >> a;
            myList[i] = a;
            i++;
        }
            for(int z = 1; z < C; z++){
                if (myList[z] == NULL) {
                    cout << "";
                } else {
                    cout << myList[z] << " ";
                }
           }
    }
}

void printList(int myList[C]){
    for(int z = 1; z < C; z++){
        if (myList[z] == NULL) {
           cout << "";
        } else {
          cout << myList[z] << " ";
        }
    }
}

void insertElement(int myList[C]){
    int x = 0;
    int kur = 0;
    cout << "Iveskite norima iterpti skaiciu: ";
    cin  >> x;
    cout << "Iveskite norima vietos numeri: ";
    cin  >> kur;
    if (myList[kur] == NULL)
    {
        myList[kur] = x;
    } else {
    for (int i = 21; i >= kur; i--)
    {
        myList[i] = myList[i-1];
    }
    myList[kur] = x;
    }
}

void deleteElement(int myList[C]){
    int kur = 0;
    cout << "Iveskite norimo istrinti elemento eiles numeri: ";
    cin  >> kur;
    myList[kur] = 0;
    for (int i = kur; i < 20; i++)
    {
        myList[i] = myList[i+1];
    }
}

void retrieveElement(int myList[C]){
    int kur = 0;
    cout << "Iveskite eiles numeri ";
    cin >> kur;
    if (myList[kur] == NULL) {
       cout << endl;
    } else {
      cout << "Rastas elementas: " << myList[kur] << " buvo " << kur << "-oje saraso vietoje.";
    }

}

void listLenght(int myList[C]){
    int kiek = 0;
    for(int z = 1; z < C; z++){
        if (myList[z] == NULL) {
           cout << "";
        } else {
          kiek += 1;
        }
    }
    cout << "Jusu sarase yra " << kiek << " elementai.";
}
